=== modified file 'bzrlib/tag.py'
--- bzrlib/tag.py	2011-09-22 13:13:43 +0000
+++ bzrlib/tag.py	2011-09-22 13:26:14 +0000
@@ -344,12 +344,11 @@
         updates = {}
         result = dict(dest_dict) # copy
         for name, target in source_dict.items():
-            if name not in result or overwrite:
-                if name not in result:
-                    updates[name] = target
+            if result.get(name) == target:
+                pass
+            elif name not in result or overwrite:
+                updates[name] = target
                 result[name] = target
-            elif result[name] == target:
-                pass
             else:
                 conflicts.append((name, target, result[name]))
         return result, updates, conflicts

=== modified file 'bzrlib/tests/test_tag.py'
--- bzrlib/tests/test_tag.py	2011-08-31 17:11:32 +0000
+++ bzrlib/tests/test_tag.py	2011-09-22 13:26:14 +0000
@@ -116,7 +116,7 @@
         # overwrite conflicts
         updates, conflicts = a.tags.merge_to(b.tags, overwrite=True)
         self.assertEqual(list(conflicts), [])
-        self.assertEqual({u'tag-1': 'x', u'tag-2': 'z'}, updates)
+        self.assertEqual({u'tag-2': 'z'}, updates)
         self.assertEqual('z', b.tags.lookup_tag('tag-2'))
 
 

